////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s             UVM Tutorial             s////
////s           gopi@testbenh.in           s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////

class demo_uvm_do extends uvm_sequence #(instruction);

  instruction req;
 
  function new(string name="demo_uvm_do");
    super.new(name);
  endfunction
  
  `uvm_sequence_utils(demo_uvm_do, instruction_sequencer)    

  virtual task pre_do(bit is_item);
       uvm_report_info(get_full_name(),"Seuqnce Action Macro Phase  : PRE_DO   ",UVM_LOW);
  endtask

  virtual function void mid_do(uvm_sequence_item this_item);
       uvm_report_info(get_full_name(),"Seuqnce Action Macro Phase  : MID_DO   ",UVM_LOW);
  endfunction

  virtual function void post_do(uvm_sequence_item this_item);
       uvm_report_info(get_full_name(),"Seuqnce Action Macro Phase  : POST_DO   ",UVM_LOW);
  endfunction 

  virtual task body();
     uvm_report_info(get_full_name(),"Seuqnce Action Macro Phase  : Before uvm_do macro ",UVM_LOW);
     `uvm_do(req);
     uvm_report_info(get_full_name(),"Seuqnce Action Macro Phase  : After uvm_do macro ",UVM_LOW);
  endtask
  
endclass 

